// Generated by BUCKLESCRIPT VERSION 6.0.0, PLEASE EDIT WITH CARE
'use strict';

var Belt_Array = require("bs-platform/lib/js/belt_Array.js");
var Belt_Option = require("bs-platform/lib/js/belt_Option.js");
var Caml_option = require("bs-platform/lib/js/caml_option.js");
var Caml_exceptions = require("bs-platform/lib/js/caml_exceptions.js");

var InvalidWeekday = Caml_exceptions.create("Intl_DateTimeFormat.InvalidWeekday");

var InvalidEra = Caml_exceptions.create("Intl_DateTimeFormat.InvalidEra");

var InvalidYear = Caml_exceptions.create("Intl_DateTimeFormat.InvalidYear");

var InvalidMonth = Caml_exceptions.create("Intl_DateTimeFormat.InvalidMonth");

var InvalidDay = Caml_exceptions.create("Intl_DateTimeFormat.InvalidDay");

var InvalidHour = Caml_exceptions.create("Intl_DateTimeFormat.InvalidHour");

var InvalidMinute = Caml_exceptions.create("Intl_DateTimeFormat.InvalidMinute");

var InvalidSecond = Caml_exceptions.create("Intl_DateTimeFormat.InvalidSecond");

var InvalidTimeZoneName = Caml_exceptions.create("Intl_DateTimeFormat.InvalidTimeZoneName");

function weekdayFromString(s) {
  switch (s) {
    case "long" : 
        return /* Long */0;
    case "narrow" : 
        return /* Narrow */2;
    case "short" : 
        return /* Short */1;
    default:
      throw [
            InvalidEra,
            s
          ];
  }
}

function eraFromString(s) {
  switch (s) {
    case "long" : 
        return /* Long */0;
    case "narrow" : 
        return /* Narrow */2;
    case "short" : 
        return /* Short */1;
    default:
      throw [
            InvalidEra,
            s
          ];
  }
}

function yearFromString(s) {
  switch (s) {
    case "2-digit" : 
        return /* TwoDigit */1;
    case "numeric" : 
        return /* Numeric */0;
    default:
      throw [
            InvalidYear,
            s
          ];
  }
}

function monthFromString(s) {
  switch (s) {
    case "2-digit" : 
        return /* TwoDigit */1;
    case "long" : 
        return /* Long */2;
    case "narrow" : 
        return /* Narrow */4;
    case "numeric" : 
        return /* Numeric */0;
    case "short" : 
        return /* Short */3;
    default:
      throw [
            InvalidMonth,
            s
          ];
  }
}

function dayFromString(s) {
  switch (s) {
    case "2-digit" : 
        return /* TwoDigit */1;
    case "numeric" : 
        return /* Numeric */0;
    default:
      throw [
            InvalidDay,
            s
          ];
  }
}

function hourFromString(s) {
  switch (s) {
    case "2-digit" : 
        return /* TwoDigit */1;
    case "numeric" : 
        return /* Numeric */0;
    default:
      throw [
            InvalidHour,
            s
          ];
  }
}

function minuteFromString(s) {
  switch (s) {
    case "2-digit" : 
        return /* TwoDigit */1;
    case "numeric" : 
        return /* Numeric */0;
    default:
      throw [
            InvalidMinute,
            s
          ];
  }
}

function secondFromString(s) {
  switch (s) {
    case "2-digit" : 
        return /* TwoDigit */1;
    case "numeric" : 
        return /* Numeric */0;
    default:
      throw [
            InvalidSecond,
            s
          ];
  }
}

function timeZoneNameFromString(s) {
  switch (s) {
    case "long" : 
        return /* Long */0;
    case "short" : 
        return /* Short */1;
    default:
      throw [
            InvalidTimeZoneName,
            s
          ];
  }
}

function resolvedOptions(self) {
  var rawResp = self.resolvedOptions();
  return /* record */[
          /* locale */Caml_option.undefined_to_opt(rawResp.locale),
          /* calendar */Caml_option.undefined_to_opt(rawResp.calendar),
          /* numberingSystem */Caml_option.undefined_to_opt(rawResp.numberingSystem),
          /* timeZone */Belt_Option.flatMap(Caml_option.undefined_to_opt(rawResp.timeZone), (function (prim) {
                  if (prim == null) {
                    return undefined;
                  } else {
                    return Caml_option.some(prim);
                  }
                })),
          /* hour12 */Caml_option.undefined_to_opt(rawResp.hour12),
          /* weekday */Belt_Option.map(Caml_option.undefined_to_opt(rawResp.weekday), weekdayFromString),
          /* era */Belt_Option.map(Caml_option.undefined_to_opt(rawResp.era), eraFromString),
          /* year */Belt_Option.map(Caml_option.undefined_to_opt(rawResp.year), yearFromString),
          /* month */Belt_Option.map(Caml_option.undefined_to_opt(rawResp.month), monthFromString),
          /* day */Belt_Option.map(Caml_option.undefined_to_opt(rawResp.day), dayFromString),
          /* hour */Belt_Option.map(Caml_option.undefined_to_opt(rawResp.hour), hourFromString),
          /* minute */Belt_Option.map(Caml_option.undefined_to_opt(rawResp.minute), minuteFromString),
          /* second */Belt_Option.map(Caml_option.undefined_to_opt(rawResp.second), secondFromString),
          /* timeZoneName */Belt_Option.map(Caml_option.undefined_to_opt(rawResp.timeZoneName), timeZoneNameFromString)
        ];
}

var InvalidPart = Caml_exceptions.create("Intl_DateTimeFormat.InvalidPart");

function formatToParts(self, date) {
  return Belt_Array.map(self.formatToParts(date), (function (rp) {
                var match = rp.type;
                var type_;
                switch (match) {
                  case "day" : 
                      type_ = /* Day */0;
                      break;
                  case "dayPeriod" : 
                      type_ = /* DayPeriod */1;
                      break;
                  case "era" : 
                      type_ = /* Era */2;
                      break;
                  case "hour" : 
                      type_ = /* Hour */3;
                      break;
                  case "literal" : 
                      type_ = /* Literal */4;
                      break;
                  case "minute" : 
                      type_ = /* Minute */5;
                      break;
                  case "month" : 
                      type_ = /* Month */6;
                      break;
                  case "second" : 
                      type_ = /* Second */7;
                      break;
                  case "timeZoneName" : 
                      type_ = /* TimeZoneName */8;
                      break;
                  case "weekday" : 
                      type_ = /* Weekday */9;
                      break;
                  case "year" : 
                      type_ = /* Year */10;
                      break;
                  default:
                    throw [
                          InvalidPart,
                          rp
                        ];
                }
                return /* record */[
                        /* type_ */type_,
                        /* value */rp.value
                      ];
              }));
}

function supportedLocalesOf(locales, localeMatcher, param) {
  var opts = { };
  var localeMatcher$prime = Belt_Option.map(localeMatcher, (function (lm) {
          if (lm) {
            return "best fit";
          } else {
            return "lookup";
          }
        }));
  if (Belt_Option.isSome(localeMatcher$prime)) {
    opts.localeMatcher = Belt_Option.getExn(localeMatcher$prime);
  }
  return Intl.DateTimeFormat.supportedLocalesOf(locales, opts);
}

function make(locales, day, era, formatMatcher, hour, hour12, hourCycle, localeMatcher, minute, month, second, timeZone, timeZoneName, weekday, year, param) {
  var day$prime = Belt_Option.map(day, (function (d) {
          if (d) {
            return "2-digit";
          } else {
            return "numeric";
          }
        }));
  var era$prime = Belt_Option.map(era, (function (e) {
          switch (e) {
            case 0 : 
                return "long";
            case 1 : 
                return "short";
            case 2 : 
                return "narrow";
            
          }
        }));
  var formatMatcher$prime = Belt_Option.map(formatMatcher, (function (fm) {
          if (fm) {
            return "best fit";
          } else {
            return "basic";
          }
        }));
  var hour$prime = Belt_Option.map(hour, (function (h) {
          if (h) {
            return "2-digit";
          } else {
            return "numeric";
          }
        }));
  var hourCycle$prime = Belt_Option.map(hourCycle, (function (hc) {
          switch (hc) {
            case 0 : 
                return "h11";
            case 1 : 
                return "h12";
            case 2 : 
                return "h23";
            case 3 : 
                return "h24";
            
          }
        }));
  var localeMatcher$prime = Belt_Option.map(localeMatcher, (function (lm) {
          if (lm) {
            return "best fit";
          } else {
            return "lookup";
          }
        }));
  var minute$prime = Belt_Option.map(minute, (function (m) {
          if (m) {
            return "2-digit";
          } else {
            return "numeric";
          }
        }));
  var month$prime = Belt_Option.map(month, (function (m) {
          switch (m) {
            case 0 : 
                return "numeric";
            case 1 : 
                return "2-digit";
            case 2 : 
                return "long";
            case 3 : 
                return "short";
            case 4 : 
                return "narrow";
            
          }
        }));
  var second$prime = Belt_Option.map(second, (function (s) {
          if (s) {
            return "2-digit";
          } else {
            return "numeric";
          }
        }));
  var timeZoneName$prime = Belt_Option.map(timeZoneName, (function (tzn) {
          if (tzn) {
            return "short";
          } else {
            return "long";
          }
        }));
  var weekday$prime = Belt_Option.map(weekday, (function (w) {
          switch (w) {
            case 0 : 
                return "long";
            case 1 : 
                return "short";
            case 2 : 
                return "narrow";
            
          }
        }));
  var year$prime = Belt_Option.map(year, (function (y) {
          if (y) {
            return "2-digit";
          } else {
            return "numeric";
          }
        }));
  var opts = { };
  if (Belt_Option.isSome(day$prime)) {
    opts.day = Belt_Option.getExn(day$prime);
  }
  if (Belt_Option.isSome(era$prime)) {
    opts.era = Belt_Option.getExn(era$prime);
  }
  if (Belt_Option.isSome(formatMatcher$prime)) {
    opts.formatMatcher = Belt_Option.getExn(formatMatcher$prime);
  }
  if (Belt_Option.isSome(hour$prime)) {
    opts.hour = Belt_Option.getExn(hour$prime);
  }
  if (Belt_Option.isSome(hour12)) {
    opts.hour12 = Belt_Option.getExn(hour12);
  }
  if (Belt_Option.isSome(hourCycle$prime)) {
    opts.hourCycle = Belt_Option.getExn(hourCycle$prime);
  }
  if (Belt_Option.isSome(localeMatcher$prime)) {
    opts.localeMatcher = Belt_Option.getExn(localeMatcher$prime);
  }
  if (Belt_Option.isSome(minute$prime)) {
    opts.minute = Belt_Option.getExn(minute$prime);
  }
  if (Belt_Option.isSome(month$prime)) {
    opts.month = Belt_Option.getExn(month$prime);
  }
  if (Belt_Option.isSome(second$prime)) {
    opts.second = Belt_Option.getExn(second$prime);
  }
  if (Belt_Option.isSome(timeZone)) {
    opts.timeZone = Belt_Option.getExn(timeZone);
  }
  if (Belt_Option.isSome(timeZoneName$prime)) {
    opts.timeZoneName = Belt_Option.getExn(timeZoneName$prime);
  }
  if (Belt_Option.isSome(weekday$prime)) {
    opts.weekday = Belt_Option.getExn(weekday$prime);
  }
  if (Belt_Option.isSome(year$prime)) {
    opts.year = Belt_Option.getExn(year$prime);
  }
  return new (Intl.DateTimeFormat)(locales, opts);
}

function rawResolvedOptions(prim) {
  return prim.resolvedOptions();
}

function format(prim, prim$1) {
  return prim.format(prim$1);
}

exports.make = make;
exports.rawResolvedOptions = rawResolvedOptions;
exports.InvalidWeekday = InvalidWeekday;
exports.InvalidEra = InvalidEra;
exports.InvalidYear = InvalidYear;
exports.InvalidMonth = InvalidMonth;
exports.InvalidDay = InvalidDay;
exports.InvalidHour = InvalidHour;
exports.InvalidMinute = InvalidMinute;
exports.InvalidSecond = InvalidSecond;
exports.InvalidTimeZoneName = InvalidTimeZoneName;
exports.resolvedOptions = resolvedOptions;
exports.format = format;
exports.InvalidPart = InvalidPart;
exports.formatToParts = formatToParts;
exports.supportedLocalesOf = supportedLocalesOf;
/* No side effect */
