// Generated by BUCKLESCRIPT VERSION 6.0.0, PLEASE EDIT WITH CARE
'use strict';

var Belt_Array = require("bs-platform/lib/js/belt_Array.js");
var Belt_Option = require("bs-platform/lib/js/belt_Option.js");
var Caml_exceptions = require("bs-platform/lib/js/caml_exceptions.js");

var InvalidPart = Caml_exceptions.create("Intl_NumberFormat.InvalidPart");

function formatToParts(self, x) {
  return Belt_Array.map(self.formatToParts(x), (function (rp) {
                var match = rp.type;
                var type_;
                switch (match) {
                  case "currency" : 
                      type_ = /* Currency */0;
                      break;
                  case "decimal" : 
                      type_ = /* Decimal */1;
                      break;
                  case "fraction" : 
                      type_ = /* Fraction */2;
                      break;
                  case "group" : 
                      type_ = /* Group */3;
                      break;
                  case "infinity" : 
                      type_ = /* Infinity */4;
                      break;
                  case "integer" : 
                      type_ = /* Integer */5;
                      break;
                  case "literal" : 
                      type_ = /* Literal */6;
                      break;
                  case "minusSign" : 
                      type_ = /* MinusSign */7;
                      break;
                  case "nan" : 
                      type_ = /* NaN */8;
                      break;
                  case "percentSign" : 
                      type_ = /* PercentSign */10;
                      break;
                  case "plusSign" : 
                      type_ = /* PlusSign */9;
                      break;
                  default:
                    throw [
                          InvalidPart,
                          rp
                        ];
                }
                return /* record */[
                        /* type_ */type_,
                        /* value */rp.value
                      ];
              }));
}

function supportedLocalesOf(locales, localeMatcher, param) {
  var opts = { };
  var localeMatcher$prime = Belt_Option.map(localeMatcher, (function (lm) {
          if (lm) {
            return "best fit";
          } else {
            return "lookup";
          }
        }));
  if (Belt_Option.isSome(localeMatcher$prime)) {
    opts.localeMatcher = Belt_Option.getExn(localeMatcher$prime);
  }
  return Intl.NumberFormat.supportedLocalesOf(locales, opts);
}

function make(locales, localeMatcher, style, useGrouping, digits, param) {
  var localeMatcher$prime = Belt_Option.map(localeMatcher, (function (lm) {
          if (lm) {
            return "best fit";
          } else {
            return "lookup";
          }
        }));
  var style$prime = Belt_Option.map(style, (function (s) {
          if (typeof s === "number") {
            if (s !== 0) {
              return "percent";
            } else {
              return "decimal";
            }
          } else {
            return "currency";
          }
        }));
  var currency$prime = Belt_Option.flatMap(style, (function (s) {
          if (typeof s === "number") {
            return undefined;
          } else {
            return s[0][/* isoCode */0];
          }
        }));
  var currencyDisplay$prime = Belt_Option.flatMap(style, (function (s) {
          if (typeof s === "number") {
            return undefined;
          } else {
            return Belt_Option.map(s[0][/* display */1], (function (d) {
                          switch (d) {
                            case 0 : 
                                return "symbol";
                            case 1 : 
                                return "code";
                            case 2 : 
                                return "name";
                            
                          }
                        }));
          }
        }));
  var minimumIntegerDigits$prime = Belt_Option.flatMap(digits, (function (d) {
          if (d.tag) {
            return undefined;
          } else {
            return Belt_Option.flatMap(d[0][/* integer */0], (function (i) {
                          return Belt_Option.map(i[/* minimum */0], (function (prim) {
                                        return prim;
                                      }));
                        }));
          }
        }));
  var minimumFractionDigits$prime = Belt_Option.flatMap(digits, (function (d) {
          if (d.tag) {
            return undefined;
          } else {
            return Belt_Option.flatMap(d[0][/* fraction */1], (function (f) {
                          return Belt_Option.map(f[/* minimum */0], (function (prim) {
                                        return prim;
                                      }));
                        }));
          }
        }));
  var maximumFractionDigits$prime = Belt_Option.flatMap(digits, (function (d) {
          if (d.tag) {
            return undefined;
          } else {
            return Belt_Option.flatMap(d[0][/* fraction */1], (function (f) {
                          return Belt_Option.map(f[/* maximum */1], (function (prim) {
                                        return prim;
                                      }));
                        }));
          }
        }));
  var minimumSignificantDigits$prime = Belt_Option.flatMap(digits, (function (d) {
          if (d.tag) {
            return Belt_Option.map(d[0][/* minimum */0], (function (prim) {
                          return prim;
                        }));
          }
          
        }));
  var maximumSignificantDigits$prime = Belt_Option.flatMap(digits, (function (d) {
          if (d.tag) {
            return Belt_Option.map(d[0][/* maximum */1], (function (prim) {
                          return prim;
                        }));
          }
          
        }));
  var opts = { };
  if (Belt_Option.isSome(localeMatcher$prime)) {
    opts.localeMatcher = Belt_Option.getExn(localeMatcher$prime);
  }
  if (Belt_Option.isSome(style$prime)) {
    opts.style = Belt_Option.getExn(style$prime);
  }
  if (Belt_Option.isSome(currency$prime)) {
    opts.currency = Belt_Option.getExn(currency$prime);
  }
  if (Belt_Option.isSome(currencyDisplay$prime)) {
    opts.currencyDisplay = Belt_Option.getExn(currencyDisplay$prime);
  }
  if (Belt_Option.isSome(useGrouping)) {
    opts.useGrouping = Belt_Option.getExn(useGrouping);
  }
  if (Belt_Option.isSome(minimumIntegerDigits$prime)) {
    opts.minimumIntegerDigits = Belt_Option.getExn(minimumIntegerDigits$prime);
  }
  if (Belt_Option.isSome(minimumFractionDigits$prime)) {
    opts.minimumFractionDigits = Belt_Option.getExn(minimumFractionDigits$prime);
  }
  if (Belt_Option.isSome(maximumFractionDigits$prime)) {
    opts.maximumFractionDigits = Belt_Option.getExn(maximumFractionDigits$prime);
  }
  if (Belt_Option.isSome(minimumSignificantDigits$prime)) {
    opts.minimumSignificantDigits = Belt_Option.getExn(minimumSignificantDigits$prime);
  }
  if (Belt_Option.isSome(maximumSignificantDigits$prime)) {
    opts.maximumSignificantDigits = Belt_Option.getExn(maximumSignificantDigits$prime);
  }
  return new (Intl.NumberFormat)(locales, opts);
}

function format(prim, prim$1) {
  return prim.format(prim$1);
}

exports.make = make;
exports.format = format;
exports.InvalidPart = InvalidPart;
exports.formatToParts = formatToParts;
exports.supportedLocalesOf = supportedLocalesOf;
/* No side effect */
